/*****************************************************************
* Unipro UGENE - Integrated Bioinformatics Suite
* Copyright (C) 2008,2009 Unipro, Russia (http://ugene.unipro.ru)
* All Rights Reserved
* 
*     This source code is distributed under the terms of the
*     GNU General Public License. See the files COPYING and LICENSE
*     for details.
*****************************************************************/

#ifndef _GB2_MUSCLE4_TASK_H_
#define _GB2_MUSCLE4_TASK_H_

#include <core_api/Task.h>
#include <gobjects/MAlignmentObject.h>
#include "Muscle4Plugin.h"

#include <QtCore/QPointer>

class Muscle4Context;

namespace GB2 {

class StateLock;
class MAlignmentObject;
class LoadDocumentTask;

class Muscle4Task : public Task {
    Q_OBJECT
public:
    Muscle4Task(const MAlignment& ma);

    void run();

    MAlignment                  inputMA;
    MAlignment                  resultMA;

    Muscle4Context*              ctx;
};


//locks MAlignment object and propagate MuscleTask results to it
class  Muscle4GObjectTask : public Task {
    Q_OBJECT
public:
    Muscle4GObjectTask(MAlignmentObject* obj);
    ~Muscle4GObjectTask();

    virtual void prepare();
    ReportResult report();

    QPointer<MAlignmentObject>  obj;
    StateLock*                  lock;
    Muscle4Task*                muscleTask;
};

}//namespace

#endif
