/*****************************************************************
* Unipro UGENE - Integrated Bioinformatics Suite
* Copyright (C) 2008,2009 Unipro, Russia (http://ugene.unipro.ru)
* All Rights Reserved
* 
*     This source code is distributed under the terms of the
*     GNU General Public License. See the files COPYING and LICENSE
*     for details.
*****************************************************************/

#ifndef _GB2_MUSCLE4_TESTS_H_
#define _GB2_MUSCLE4_TESTS_H_

#include <test_framework/xmltest/XMLTestUtils.h>
#include <core_api/GObject.h>

#include <QtCore/QFileInfo>
#include <QtXml/QDomElement>

#include "Muscle4Task.h"

namespace GB2 {

class MuscleGObjectTask;
class MAlignmentObject;
class LoadDocumentTask;
class MAlignment;

class GTest_muscle4 : public GTest {
    Q_OBJECT
public:
    SIMPLE_XML_TEST_BODY_WITH_FACTORY(GTest_muscle4, "umuscle4");
    
    void prepare();
    Task::ReportResult report();

private:    
    QString inputDocCtxName;
    Document* doc;
    Muscle4GObjectTask* mTask;
    MAlignmentObject *ma_result;
};


class  Muscle4Tests {
public:
    static QList<XMLTestFactory*> createTestFactories();
};
}//namespace
#endif
